#! /usr/bin/env python
# -*- coding: utf-8 -*-
####################
# seconds since last change Plugin
# Developed by Karl Wachs
# karlwachs@me.com

import os, sys, re, Queue, threading, subprocess, pwd,urllib2
import datetime, time
import simplejson as json
from time import gmtime, strftime, localtime
import urllib
import fcntl
import signal
import copy




'''
how it works:
1. add/remove device/state/frequency to be tracked in config
2. loop every 0.2 seconds and check if nect device/state is due to be changed
3. compare devcei/state with old value
4. if different reset variable: seconds_deviceName_state to 0
   if same, increment variable
5.
'''
Version="0.6.7"


emptyDev={"states":{}}
emptyState={"lastChange":0,"lastCheck":0,"checkFrequency":0,"lastValue":""}

################################################################################
class Plugin(indigo.PluginBase):

    ########################################
    def __init__(self, pluginId, pluginDisplayName, pluginVersion, pluginPrefs):
        indigo.PluginBase.__init__(self, pluginId, pluginDisplayName, pluginVersion, pluginPrefs)
    
    
    ########################################
    def __del__(self):
        indigo.PluginBase.__del__(self)
    
    ########################################
    def startup(self):

        self.debugLevel			= int(self.pluginPrefs.get("debugLevel",255))
        self.loopTest			= float(self.pluginPrefs.get("loopTest",2.0))
        self.devList			= json.loads(self.pluginPrefs.get("devList","{}"))
        for dd in self.devList:
            for ss in self.devList[dd]["states"]:
                if "previousChange" not in self.devList[dd]["states"][ss]:
                    self.devList[dd]["states"][ss]["previousChange"] =0
    
        self.subscribe			= self.pluginPrefs.get("subscribe","loop")
        
        self.variFolderName		= self.pluginPrefs.get("variFolderName","Seconds")
        self.saveNow			= False
        self.devID 				= 0
        self.quitNow			= "" # set to !="" when plugin should exit ie to restart, needed for subscription -> loop model
        self.printConfigCALLBACK()
        self.stopConcurrentCounter = 0
        self.pluginPrefs["devList"] =json.dumps(self.devList)
        
        return

########################################


    ########################################
    def deviceStartComm(self, dev):
        return
    
    ########################################
    def deviceStopComm(self, dev):
        return
    ########################################
    def stopConcurrentThread(self):
        self.stopConcurrentCounter +=1
        self.myLog(255,u"stopConcurrentThread called " + str(self.stopConcurrentCounter))
        if self.stopConcurrentCounter ==1:
            self.stopThread = True



    ########################################
    def variableUpdated(self, origVar, newVar):
        if origVar.name.find("pi1In") >-1:
            self.myLog(255,u"pi changed: " +unicode(origVar.value)+" new: "+ unicode(newVar.value))
    

    ########################################
    def deviceUpdated(self, origDev, newDev):
        if self.subscribe !="subscribe": return
        devstr = str(origDev.id)
        if devstr not in self.devList: return

        now=time.time()
        ddd =self.devList[devstr]
        devName= origDev.name
        self.myLog(2,"checking :"+devName)

        for state in self.devList[devstr]["states"]:
            self.myLog(2,"checking :"+state)
            if state not in newDev.states: continue
            if origDev.states[state] == newDev.states[state]: continue
            # change happend for dev/state we asked for, now rest conter ...
            sss = ddd["states"][state]
            variName= "seconds_"+devName.replace(" ","_")+"_"+state.replace(" ","_")
            variNamePrevious= "secondsPrevious_"+devName.replace(" ","_")+"_"+state.replace(" ","_")

            self.myLog(2,"changed: "+ variName+ " : "+unicode(newDev.states[state]))
            try:
                vari = indigo.variables[variName]
            except:
                indigo.variable.create(variName,"0",self.variFolderName)
            
            try:
                variPrevious = indigo.variables[variNamePrevious]
            except:
                indigo.variable.create(variNamePrevious,"0",self.variFolderName)

            sss["lastValue"]=newDev.states[state]
            indigo.variable.updateValue(variNamePrevious, str(int(now - sss["lastChange"])))
            indigo.variable.updateValue(variName,"0")
            sss["previousChange"]= sss["lastChange"]
            sss["lastChange"]= now
            sss["lastCheck"] = now

        return
    

####-----------------  set the geneeral config parameters---------
    def validatePrefsConfigUi(self, valuesDict):

        self.debugLevel			= int(valuesDict[u"debugLevel"])
        self.variFolderName		= valuesDict[u"variFolderName"]
        self.loopTest			= float(valuesDict[u"loopTest"])
        xx= valuesDict[u"subscribe"]
        if xx != self.subscribe:
            if xx=="subscribe":
                indigo.devices.subscribeToChanges()
                indigo.variables.subscribeToChanges()
            else:
                self.quitNow="yes" # need to restart
                self.myLog(255,"restart plugin needed to UNsubscribe to changes")

        self.subscribe = xx

        try:
            indigo.variables.folder.create(self.variFolderName)
        except:
            pass
        return True, valuesDict


    ########################################
    def dummyCALLBACK(self):
        
        return
    ########################################
    def printConfigCALLBACK(self,devstr=""):
        self.myLog(255,"Configuration: Dev-Name    DevID....                   State     Parameters ........")
        for devid in self.devList:
            if devid == devstr or devstr=="":
                for state in self.devList[devid]["states"]:
                    self.myLog(255, indigo.devices[int(devid)].name.ljust(25) +"; "+devid.ljust(10)+";  "+state.rjust(20)+" :"+ unicode(self.devList[devid]["states"][state]) )
        
        return
    ########################################
    def pickDeviceCALLBACK(self,valuesDict="",typeId=""):				# Select only device/properties that are supported
        self.myLog(4,unicode(valuesDict))
        self.devID= int(valuesDict["device"])
        return valuesDict

    ########################################
    def filterStates(self,filter="",valuesDict="",typeId=""):				# Select only device/properties that are supported
    
        if self.devID ==0: return [(0,0)]
        retList=[]
        dev =  indigo.devices[self.devID]
        for state in dev.states.keys():
            retList.append((state, state))
        return retList



    ########################################
    def buttonConfirmCALLBACK(self,valuesDict="",typeId=""):				# Select only device/properties that are supported
        dev=indigo.devices[int(valuesDict["device"])]
        devstr= str(dev.id)
        if devstr not in self.devList:
            self.devList[devstr]				= copy.deepcopy(emptyDev)
        
        state = valuesDict["state"]
        if  state not in self.devList[devstr]["states"]:
            self.devList[devstr]["states"][state]	=copy.deepcopy(emptyState)
        
        self.devList[devstr]["states"][state]["checkFrequency"]	= int(valuesDict["checkFrequency"])
        self.devList[devstr]["states"][state]["lastChange"]		= time.time()
        self.devList[devstr]["states"][state]["lastCheck"]		= 0
        self.saveNow=True
        
        self.printConfigCALLBACK(devstr=devstr)

        return valuesDict

    ########################################
    def buttonRemoveCALLBACK(self,valuesDict="",typeId=""):				# Select only device/properties that are supported
        dev=indigo.devices[int(valuesDict["device"])]
        devstr= str(dev.id)
        if devstr in self.devList:
            state = valuesDict["state"]
            if  state in self.devList[devstr]["states"]:
                del self.devList[devstr]["states"][state]
    
        self.printConfigCALLBACK()

        return valuesDict



    ########### main loop -- start #########
    ########################################
    def runConcurrentThread(self):

        if self.subscribe =="subscribe":
            indigo.devices.subscribeToChanges()
            indigo.variables.subscribeToChanges()

        lastSave=time.time()
        try:
            while self.quitNow =="":
                now=time.time()
                if self.saveNow or lastSave +60 < now:
                    self.pluginPrefs["devList"] =json.dumps(self.devList)
                    self.saveNow=False
                delList=[]    
                for devID in self.devList:
                    if int(devID) >0:
                        try:
                            devName= indigo.devices[int(devID)].name
                        except Exception, e:
                           if unicode(e).find("timeout") >-1: self.sleep(5)
                        try:
                            devName = indigo.devices[int(devID)].name
                        except:
                                self.myLog(255," error; device with indigoID = "+ str(devID) +" does not exist, removing from tracking")
                                delList.append(devID)
                                continue
                               
                    ddd =self.devList[devID]
                    for state in ddd["states"]:
                        sss = ddd["states"][state]
                        variName= "seconds_"+devName.replace(" ","_")+"_"+state.replace(" ","_")
                        variNamePrevious= "secondsPrevious_"+devName.replace(" ","_")+"_"+state.replace(" ","_")
                        
                        self.myLog(1,"variName "+variName+" "+variNamePrevious)
                        self.myLog(1,str(sss["lastCheck"])+ " + "+str(sss["checkFrequency"])+"  < " +str(now))
                        if self.subscribe !="subscribe":
                            if not( (sss["lastCheck"] + sss["checkFrequency"]) < now or indigo.devices[int(devID)].states[state] != sss["lastValue"]) : continue
                        elif  not ( (sss["lastCheck"] + sss["checkFrequency"]) < now ) : continue
                        
                        sss["lastCheck"] = now
                        self.myLog(1,variName+ " : "+unicode(ddd))
                        try:
                            vari = indigo.variables[variName]
                        except:
                            indigo.variable.create(variName,"0",self.variFolderName)
                            vari = indigo.variables[variName]
                        Value= vari.value
                        
                        try:
                            variPrevious = indigo.variables[variNamePrevious]
                        except:
                            indigo.variable.create(variNamePrevious,"0",self.variFolderName)
                            variPrevious = indigo.variables[variNamePrevious]
                        ValuePrevious = float(variPrevious.value)

                        if indigo.devices[int(devID)].states[state] != sss["lastValue"]:
                            sss["lastValue"]=indigo.devices[int(devID)].states[state]
                            indigo.variable.updateValue(variNamePrevious, Value )
                            indigo.variable.updateValue(variName,"0")
                            indigo.variable.updateValue(variNamePrevious, str(int(now-float(sss["lastChange"]))) )
                            sss["previousChange"]=sss["lastChange"]
                            sss["lastChange"]=now
                        elif (sss["lastChange"] + sss["checkFrequency"]) < now :
                            indigo.variable.updateValue(variName, str(int(now-float(sss["lastChange"]))) )
                            indigo.variable.updateValue(variNamePrevious, str(int(now-float(sss["previousChange"]))) )
                for devID in delList:
                    del self.devList[devID]

                self.sleep(self.loopTest)
            self.stopConcurrentCounter = 1
            serverPlugin = indigo.server.getPlugin(self.pluginId)
            serverPlugin.restart(waitUntilDone=False)
            self.sleep(1)
        except  Exception, e:
            if len(unicode(e)) > 5:
                self.myLog(-1,"error in  Line '%s' ;  error='%s'" % (sys.exc_traceback.tb_lineno, e))
        self.pluginPrefs["devList"] =json.dumps(self.devList)
        self.quitNow ==""
        return





####----------------- logfile  ---------
    def myLog(self,msgLevel,text,type=""):
        if msgLevel ==0: return
        if msgLevel ==-1:
            indigo.server.log(u"--------------------------------------------------------------")
            indigo.server.log(text)
            indigo.server.log(u"--------------------------------------------------------------")
            return
        if msgLevel ==-2:
            self.errorLog(u"----------------------------------------------------------------------------------" )
            self.errorLog(text)
            self.errorLog(u"----------------------------------------------------------------------------------" )
            return
        if msgLevel ==255:
            if type =="": indigo.server.log(text)
            else:		  indigo.server.log(text,type=type)
            return
        if self.debugLevel ==255:
            if type =="": indigo.server.log(text)
            else:		  indigo.server.log(text,type=type)
            return
        if self.debugLevel&msgLevel >0:
            if type =="": indigo.server.log(text)
            else:		  indigo.server.log(text,type=type)
            return


